<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 07/10/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : language.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Language loader                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sprache-Lader                                    *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF']))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Set default language
if (empty($mx_lang)) $mx_lang = DEFAULT_LANG;

// Look for file
$file = sprintf(PATH."inc/language/%s.php", $mx_lang);
if ((!file_exists($file)) || (!is_readable($file))) {
	// Switch to default (DO NOT CHANGE!!!)
	set_session("mx_lang", "de");
	$mx_lang = "de";
	$file = sprintf(PATH."inc/language/%s.php", $mx_lang);
}

// Load language file
require($file);
unset($file);

// Check for installation mode
if (isBooleanConstantAndTrue('mxchange_installing')) {
	// Load matching language file
	require(PATH."inc/language/install_".$mx_lang.".php");
}

//
?>
